#include <iostream>
#include <autodiff/forward/dual.hpp>
using namespace std;
using namespace autodiff;
dual f(const dual &x,const dual &y,const dual &z)
{
 return (x+y+z)*exp(x*y+z);
}

int main()
{
    dual x = 1.0; dual y = 2.0;
    dual z = 3.0; dual u = f(x, y, z);
    double dudx = derivative(f, wrt(x), at(x, y, z));
    double dudy = derivative(f, wrt(y), at(x, y, z));
    double dudz = derivative(f, wrt(z), at(x, y, z));
    cout<<"Derivatives "<<dudx<<" "<<dudy<<" "<<dudz<<endl;
    return 0;
}
